## alicevision 3.2.0%2Brepack

=== debian/control ===
Source: alicevision
Section: contrib/libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libgeogram-dev,
               libapriltag-dev,
               libflann-dev,
               libnanoflann-dev,
               liblemon-dev,
               libcoin-dev,
               libceres-dev,
               libassimp-dev,
               libboost-atomic-dev,
               libboost-container-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-json-dev,
               libboost-log-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-timer-dev,
               libboost-test-dev,
               libopenimageio-dev,
               openimageio-tools,
               libmetis-dev,
               libopengv-dev,
               libopencv-dev,
               libmeshsdfilter-dev,
               libopenmesh-dev,
               libexpat1-dev,
               python3-imath,
               libtbb-dev,
               coinor-libcoinutils-dev,
               coinor-libclp-dev,
               liblz4-dev
Standards-Version: 4.6.0
Homepage: https://github.com/alicevision/AliceVision
Vcs-Git: https://salsa.debian.org/science-team/alicevision.git
Vcs-Browser: https://salsa.debian.org/science-team/alicevision

Package: libalicevision3
Section: contrib/libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libalicevision-data (= ${source:Version})
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the shared library

Package: libalicevision-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libalicevision3 (= ${binary:Version})
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the development files library

Package: libalicevision-data
Section: contrib/libs
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the data files

Package: alicevision
Section: contrib/science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libalicevision3 (= ${binary:Version})
Description: Photogrammetric Computer Vision Framework
 AliceVision aims to provide strong software basis with state-of-the-art
 computer vision algorithms that can be tested, analyzed and reused. The project
 is a result of collaboration between academia and industry to provide
 cutting-edge algorithms with the robustness and the quality required for
 production usage.
 .
 This package provides the executable tools
