## alicevision 3.2.0+repack

=== debian/changelog ===
alicevision (3.2.0+repack-2build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:25:00 +0200

alicevision (3.2.0+repack-2) unstable; urgency=medium

  * Fixed FTBFS with nanoflann 1.7.0 (Closes: #1098340)

 -- Dima Kogan <dkogan@debian.org>  Thu, 20 Feb 2025 23:27:25 -0800

alicevision (3.2.0+repack-1) unstable; urgency=medium

  * First release into Debian (Closes: #1015716)

 -- Dima Kogan <dkogan@debian.org>  Sun, 19 Jan 2025 17:02:27 -0800
